package com.joshvm.demo;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import javax.microedition.io.Connector;
import javax.microedition.io.HttpConnection;

/**
 * HTTP实例：请求百度，读取响应
 * 前提：网关需要插入SIM卡，有网络
 */
public class HttpDemo {
	// IP
	private static String ip = "www.baidu.com";
	// 端口
	private static String port = "80";

	private static HttpConnection httpConnection;
	private static InputStream inputStream;
	private static OutputStream outputStream;

	public static void main(String[] args) {

		System.out.println("Start Http Demo...");

		try {
			String url = "http://" + ip + ":" + port;

			httpConnection = (HttpConnection) Connector.open(url);
			System.out.println("connect..." + url);

			httpConnection.setRequestMethod(HttpConnection.GET);
			httpConnection.setRequestProperty("Content-Type", "application/json;charset=UTF-8");

			outputStream = httpConnection.openOutputStream();

			int rc = httpConnection.getResponseCode();
			System.out.println("responseCode:" + rc);
			if (rc == HttpConnection.HTTP_OK) {
				inputStream = httpConnection.openInputStream();
				int length = (int) httpConnection.getLength();
				System.out.println("length:" + length);
				int len = 0;
				byte[] buffer = new byte[1024];
				// 读数据
				while ((len = inputStream.read(buffer)) > 0) {
					System.out.println(new String(buffer, 0, len, "utf-8"));
				}
			} else {
				throw new IOException("HTTP response code: " + rc);
			}
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			closeStream();
		}

	}

	/**
	 * 关闭连接
	 */
	private static void closeStream() {

		try {
			if (inputStream != null) {

				inputStream.close();
			}

			if (outputStream != null) {

				outputStream.close();
			}

			if (httpConnection != null) {

				httpConnection.close();
			}
		} catch (IOException e) {
			e.printStackTrace();
		}

	}

	/**
	 * 发送数据
	 * 
	 * @param buffer
	 * @param off
	 * @param len
	 */
	private static void sendData(byte[] buffer) {
		try {
			if (outputStream != null) {
				System.out.println("send...");
				outputStream.write(buffer, 0, buffer.length);
				outputStream.flush();
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
